<template>
  <v-expand-transition>
    <v-card
      :key="isMinified"
      :color="$store.state.primaryColor" dark
      class="ml-12"
    >
      <!-- For every available track -->
      <!-- Create a link to the sync editor of each track -->
      <!-- 'no-active' is used to replace the vuetify active link system -->
      <v-list-item
        v-for="index in usableTrackIndices"
        v-show="!isMinified"
        :key="index"
        dense
        :class="{ 'no-active': $route.query.sync !== index.toString() }"
        link :to="{query: { sync: index }}"
      >
        <v-list-item-content>
          <v-list-item-title>
            Track {{ index + 1 }}
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </v-card>
  </v-expand-transition>
</template>

<script lang="ts">
import {
  Vue, Component, Prop,
} from 'vue-property-decorator';
import type { Piece } from '@/data';

@Component
export default class AnalysisSidebarItems extends Vue {
  analysesList: string[] = [];

  @Prop()
  piece!: Piece;

  get usableTrackIndices(): number[] {
    // Get all tracks and their index
    const tracks = this.piece.tracks.map((track, index) => [track, index] as const);

    // Filter for all tracks that have waveforms
    const validTracks = tracks.filter(([track]) => this.piece.sources.some(
      (source) => source.track === track,
    ));

    // Return the index
    return validTracks.map(([, index]) => index);
  }

  @Prop({ default: false })
  isMinified!: boolean;
}

</script>
